///-----------------------------------------------------------------
///
/// @file      FastAcessFrm.h
/// @author    Jacek
/// Created:   2010-11-03 19:24:42
/// @section   DESCRIPTION
///            FastAcessFrm class declaration
///
///------------------------------------------------------------------

#ifndef __FASTACESSFRM_H__
#define __FASTACESSFRM_H__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/frame.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/menu.h>
////Header Include End

////Dialog Style Start
#undef FastAcessFrm_STYLE
#define FastAcessFrm_STYLE wxCAPTION | wxRESIZE_BORDER | wxSYSTEM_MENU | wxMINIMIZE_BOX | wxMAXIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class FastAcessFrm : public wxFrame
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		FastAcessFrm(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("FastAcess"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = FastAcessFrm_STYLE);
		virtual ~FastAcessFrm();
		void FastAcessFrmPaint(wxPaintEvent& event);
		void FastAcessFrmSize(wxSizeEvent& event);
		void FastAcessFrmLeftUP(wxMouseEvent& event);
		
	private:
		//Do not add custom control declarations between
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxMenuBar *WxMenuBar1;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_MNU_WYB_RMETODY_1001 = 1001,
			ID_MNU_INTERNAL_1002 = 1002,
			ID_MNU_DIGITALDIFFERENTIALALGORITHM_1003 = 1003,
			ID_MNU_EXTREMALYFASTLINEALGORITHM__1004 = 1004,
			ID_MNU_NORMAL_1009 = 1009,
			ID_MNU_FAST_1010 = 1010,
			
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
		
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
};

#endif
