//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TPoint Bez[8];
bool Moving=false;
int PntNumber, oldX,oldY;

void MyBezier(TCanvas *cnv, TPoint pnt[4])
{
 int i;
 float t,X,Y;
 cnv->MoveTo(pnt[0].x,pnt[0].y);
 cnv->LineTo(pnt[1].x,pnt[1].y);
 cnv->LineTo(pnt[2].x,pnt[2].y);
 cnv->LineTo(pnt[3].x,pnt[3].y);
 for (i=0; i<1001; i++)
 {
  t=i/1000.0;
  X=pnt[0].x*(1-t)*(1-t)*(1-t)+pnt[1].x*3*t*(1-t)*(1-t)+pnt[2].x*3*t*t*(1-t)+pnt[3].x*t*t*t;
  Y=pnt[0].y*(1-t)*(1-t)*(1-t)+pnt[1].y*3*t*(1-t)*(1-t)+pnt[2].y*3*t*t*(1-t)+pnt[3].y*t*t*t;
  cnv->Pixels[X][Y]=clRed;
 }
}

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
 Bez[0].x=10; Bez[0].y=10;
 Bez[1].x=30; Bez[1].y=50;
 Bez[2].x=10; Bez[2].y=100;
 Bez[3].x=30; Bez[3].y=150;

 Bez[4].x=210; Bez[4].y=10;
 Bez[5].x=230; Bez[5].y=50;
 Bez[6].x=210; Bez[6].y=100;
 Bez[7].x=230; Bez[7].y=150;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
 int i;
 Canvas->Pen->Mode=pmNotXor;
 for (i=0; i<8; i++)
  Canvas->Rectangle(Bez[i].x-3,Bez[i].y-3,Bez[i].x+3,Bez[i].y+3);
 Canvas->PolyBezier(Bez,3);
// Canvas->PolyBezier(Bez+4,3);
 MyBezier(Canvas,Bez+4);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
 int i;
 for (i=0; i<8; i++)
  if ((X>Bez[i].x-4) && (X<Bez[i].x+4) && (Y>Bez[i].y-4) && (Y<Bez[i].y+4))
  {
   Moving=true;
   PntNumber=i;
   oldX=Bez[i].x;
   oldY=Bez[i].y;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
 if (Moving)
 {
  Moving=false;

 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
 if (Moving)
 {
  Canvas->Pen->Mode=pmNotXor;
  Canvas->Rectangle(oldX-3,oldY-3,oldX+3,oldY+3);
  Canvas->PolyBezier(Bez,3);
//  Canvas->PolyBezier(Bez+4,3);
  MyBezier(Canvas,Bez+4);
  oldX=X; oldY=Y;
  Bez[PntNumber].x=X;
  Bez[PntNumber].y=Y;
  Canvas->Rectangle(oldX-3,oldY-3,oldX+3,oldY+3);
  Canvas->PolyBezier(Bez,3);
//  Canvas->PolyBezier(Bez+4,3);
  MyBezier(Canvas,Bez+4);
 } 
}
//---------------------------------------------------------------------------
