//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Real.h"
#include "Device.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#define MAXPNT 29

TPoint pnt1[MAXPNT],pnt2[MAXPNT];
extern TPoint dev_pnt1[20],dev_pnt2[20];
extern float x0,y0,x1,y1;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
 int i;
 Canvas->Pen->Color=clBlue;
 Canvas->Rectangle(x0,y0,x1,y1);
 Canvas->Pen->Color=clBlack;
 for (i=0; i<MAXPNT; i++)
 {
  Canvas->MoveTo(pnt1[i].x,pnt1[i].y);
  Canvas->LineTo(pnt2[i].x,pnt2[i].y);
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
 Form2->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
 if (Button==mbLeft) {x0=X; y0=Y;};
 if (Button==mbRight) {x1=X; y1=Y;};
 Invalidate();
 Form2->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
 x0=y0=0;
 x1=ClientWidth;
 y1=ClientHeight;
 pnt1[0]=TPoint(30,450);         pnt2[0]=TPoint(240,450);
 pnt1[1]=TPoint(240,450);        pnt2[1]=TPoint(240,240);
 pnt1[2]=TPoint(240,240);        pnt2[2]=TPoint(30,240);
 pnt1[3]=TPoint(30,240);         pnt2[3]=TPoint(30,450);
 pnt1[4]=TPoint(30,240);         pnt2[4]=TPoint(180,150);
 pnt1[5]=TPoint(180,150);        pnt2[5]=TPoint(240,240);

 pnt1[6]=TPoint(300,420);        pnt2[6]=TPoint(550,420);
 pnt1[7]=TPoint(550,420);        pnt2[7]=TPoint(550,300);
 pnt1[8]=TPoint(550,300);        pnt2[8]=TPoint(420,300);
 pnt1[9]=TPoint(420,300);        pnt2[9]=TPoint(390,360);
 pnt1[10]=TPoint(390,360);        pnt2[10]=TPoint(300,390);
 pnt1[11]=TPoint(300,390);        pnt2[11]=TPoint(300,420);

 pnt1[12]=TPoint(330,420);        pnt2[12]=TPoint(330,450);
 pnt1[13]=TPoint(330,450);        pnt2[13]=TPoint(360,450);
 pnt1[14]=TPoint(360,450);        pnt2[14]=TPoint(360,420);
 pnt1[15]=TPoint(490,420);        pnt2[15]=TPoint(490,450);
 pnt1[16]=TPoint(490,450);        pnt2[16]=TPoint(520,450);
 pnt1[17]=TPoint(520,450);        pnt2[17]=TPoint(520,420);

 pnt1[18]=TPoint(620,180);        pnt2[18]=TPoint(620,150);
 pnt1[19]=TPoint(620,150);        pnt2[19]=TPoint(650,150);
 pnt1[20]=TPoint(650,150);        pnt2[20]=TPoint(650,180);

 pnt1[21]=TPoint(620,240);        pnt2[21]=TPoint(620,450);
 pnt1[22]=TPoint(620,450);        pnt2[22]=TPoint(650,450);
 pnt1[23]=TPoint(650,450);        pnt2[23]=TPoint(650,240);

 pnt1[24]=TPoint(710,180);        pnt2[24]=TPoint(550,180);
 pnt1[25]=TPoint(550,180);        pnt2[25]=TPoint(520,210);
 pnt1[26]=TPoint(520,210);        pnt2[26]=TPoint(550,240);
 pnt1[27]=TPoint(550,240);        pnt2[27]=TPoint(710,240);
 pnt1[28]=TPoint(710,240);        pnt2[28]=TPoint(710,180);

}
//---------------------------------------------------------------------------
